package vishnu.testvis.evaluate;
import java.io.*; 
import java.util.*;

public class Queries
{
    Vector queryID;
    Vector queryString;
    Vector relevance[];

    public Queries()
    {
        getQueries();
        
        // only of the queries just read
        getRelevanceData();
        //printRelevance();
    }
    
    private void getRelevanceData()
    {
        
        relevance = new Vector[queryID.size()];
        for( int i = 0; i < queryID.size(); i++ )
        {
            relevance[i] = new Vector();            
        }
        
        try
        {
		    FileReader file = new FileReader("qrels.dat");
		    BufferedReader buff = new BufferedReader(file);
		    
		    String line = buff.readLine();
		    //System.out.println(line);
		    		    
		    StringTokenizer st = new StringTokenizer(line);
		    String id = st.nextToken();
		    //System.out.println(id);
		    int index = 0;
		    if( queryID.contains(id) )
		    {
		        index = queryID.indexOf(id);
		        //System.out.println("Contained at position " + index);
		    }
		    
		    String docStr = st.nextToken();
		    //System.out.println(docStr);
		    relevance[index].addElement(docStr);
		    boolean eof = false;
		    			
		    while( !eof ) 
		    {
		        line = new String();
			    line = buff.readLine();	
			    
			    if( line == null || line == "" )
			        eof = true;
			    else
			    {
			        st = new StringTokenizer(line);
	    	    	id = st.nextToken();
		            if( queryID.contains(id) )
		            index = queryID.indexOf(id);
		            docStr = st.nextToken();
		            relevance[index].addElement(docStr);
		            st = new StringTokenizer(line);
		        }
	        }
	        buff.close();	
		}
		catch( IOException e)
		{
			System.out.println("Error -- " + e.toString());
		}    
    }
    
    
    private void getQueries()
    {
        queryID = new Vector();
        queryString = new Vector();
        
        try
		{
		    FileReader file = new FileReader("queries.dat");
		    BufferedReader buff = new BufferedReader(file);
		    
		    String line = buff.readLine();
		    //System.out.println(line);
		    		    
		    StringTokenizer st = new StringTokenizer(line);
		    
		    String keywords = new String();
		    
		    while( st.hasMoreTokens() )
		    {
		        String strTemp = st.nextToken();
		        
		        // check whether token is last token
		        // assume last token is the query number
		        if( !st.hasMoreTokens() )
		        {
		            queryID.addElement(strTemp);
		            keywords = keywords.trim();
		            queryString.addElement(keywords);
		        }
		        else
		        {
		            keywords += " " + strTemp;
		        }
		    }
		   	    
            boolean eof = false;
			
		    while( !eof )
		    {
		        line = new String();
			    line = buff.readLine();	
			    //System.out.println(line);
			    if( line == null || line == "" )
			        eof = true;
			    else
			    {   
	    		    keywords = new String();
		    
		            st = new StringTokenizer(line);
		            while( st.hasMoreTokens() )
		            {
		                String strTemp = st.nextToken();
		                
		                // check whether token is last token
		                // assume last token is the query number
		                if( !st.hasMoreTokens() )
		                {
		                    queryID.addElement(strTemp);
		                    queryString.addElement(keywords);
		                    //System.out.println(keywords);
		                }
		                else
		                {
		                    keywords += " " + strTemp;
		                }
		            }
        		}
	        }
	        buff.close();	
		}
		catch( IOException e)
		{
			System.out.println("Error -- " + e.toString());
		}
	}
        
    public Object[] getQueryObjectArray()
    {
        Object[] objArray = new Object[queryString.size()];
	    for( int i = 0; i < queryString.size(); i++ )
		{
		    objArray[i] = queryString.elementAt(i);
		}
		return objArray;
    }
        
    public Vector getQueryIDs()
    {
        return queryID;
    }
    
    
    public void printRelevance()
    {
        for( int i = 0; i < relevance.length; i++ )
        {
            for( int j = 0; j < relevance[i].size(); j++ )
            {
                System.out.print((String)relevance[i].elementAt(j));
            }
            System.out.println();
            System.out.println();
        }
    }
    
    // returns vector with first element = total of relevant followed
    // by precision at 10, 20...
    public Vector getPerformance(String query, String rankedTrecIDs[])
    {
        int num = 0;
        Vector precisionAt = new Vector();
        int index = queryString.indexOf(query);
        //System.out.println("Query number " + index + " selected");
        if( index == -1 )
            return precisionAt;  // return empty vector
                
        boolean relevant[] = new boolean[rankedTrecIDs.length];
        //System.out.println("Size of ranked list: " + rankedTrecIDs.length);
        
        for( int i = 0; i < rankedTrecIDs.length; i++ )
        {
            // determine for each doc in the list whether it is relevant
            if( relevance[index].contains(rankedTrecIDs[i]) )
            {
                relevant[i] = true;
                num++;
            }
            else 
                relevant[i] = false;
                
            // precision at 10,20,30,40,50    
            if( (i+1) % 10 == 0 && (i+1)/10 < 6)
            {
                Integer prec = new Integer(Math.round(((float)num/(i+1)*100)));
                
                //System.out.println((double)num/(i+1));
                precisionAt.addElement(prec);
                
            }    
        }
        
        precisionAt.addElement(new Integer(relevance[index].size()));
        precisionAt.addElement(new Integer(num));
        //System.out.println(num + " relevant docs from a total of " + relevance[index].size() + " have been found");
        
        return precisionAt;
  }
    
}

/*		int totalRel = no_in_cat[categories.indexOf(queryId)]-1; // number of relevant
		int relSoFar = 0;
		
		int pre_vs_rec[] = new int[11];
			
				
		// trec method to compute average precision
		// compute P for relevant images only
		// P(r0) = max(P(r >= r0))

		
		// the following array stores pre/rec for every relevant, the first 
		// entry is precision for the 0th item = 0.
		// maximum size of array = items.length
		// actual size of array = totalRel
		
		int recall = 0;
		int precision = 0;
		
		
		// begin of Rueger method
		
		relSoFar = totalRel;
            
	   	    // i  = 1 because target img is at zero!!!
	   	    int maxPrecision = 0;
	   	    int cutL = 10;
		    for( int i = no_of_items -1; i > 0; i-- )
			{
				String listId = new
			    String((String)cat_of_item.elementAt((int)list[i]));
				if( listId.equals(queryId) )
			    {
			        recall = (int)(100*relSoFar)/totalRel;
			        
			        precision = (int)(100*relSoFar)/i;
			        

			        double cut = (double)(recall)/10;
			        
			        //if( r == 6 ) System.out.print(recall + " " + precision + ":");
			        			        
                    // if hit the next cut-off cutL, then set cut-off value to whatever 
                    // is maximum
			        if( cut == cutL )
			        {
			            //System.out.print("eq ");
			            if( precision > maxPrecision )
			            {
			              //  System.out.print("eq-cm(" + precision + ") ");
			                maxPrecision = precision;
			            }
                        
                        //System.out.print("eq-ap(" + maxPrecision + ") ");
			            pre_vs_rec[cutL] = maxPrecision;
			            cutL--;
			        }
			        
			        // if moved to the left of cut-off, the cut-off value (and those
			        // lying between it and the last one set) is given the 
			        // current maxPrecision
			        else if( cut < cutL )   
			        {
			            for( int c = (int)cut+1; c < cutL+1; c++ )
			            {
			                pre_vs_rec[c] = maxPrecision;
			            }
			            
			            
			            if( precision > maxPrecision )
			            {
			                maxPrecision = precision;
			            }
			            
			            cutL = (int)cut;
    
			        }
		
		            
			        
			        // just in case cut > cutL, we need still to update maxPrecision
			        if( precision > maxPrecision )
			        {
			            maxPrecision = precision;
			        }
			        relSoFar--;
			    
			    }
			    // if not relevant, nothing happens
		    }
		    
		    for( int z = 0; z < cutL+1; z++ )
		    {
		        pre_vs_rec[z] = maxPrecision;
		    }
		    	    
            // end of Rueger method
		
		// average precision for this query                                                     
		double area = 0;
		for(int j = 0; j < 10; j++ )
		{
			area += (pre_vs_rec[j]+pre_vs_rec[j+1])/2* 0.1;
		}
			
		Performance p = new Performance(area, pre_vs_rec, queryId);
		return p;
  
	}
*/
